VERSION 5.00
Begin VB.Form frmMasken 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Masken"
   ClientHeight    =   2955
   ClientLeft      =   150
   ClientTop       =   435
   ClientWidth     =   4140
   FillStyle       =   0  'Solid
   Icon            =   "frmMasken.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   197
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   276
   StartUpPosition =   2  'CenterScreen
   Begin VB.PictureBox picFood 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   480
      Left            =   3000
      Picture         =   "frmMasken.frx":0442
      ScaleHeight     =   32
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   32
      TabIndex        =   5
      Top             =   1920
      Width           =   480
      Visible         =   0   'False
   End
   Begin VB.PictureBox picHead 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   240
      Left            =   2280
      Picture         =   "frmMasken.frx":04C6
      ScaleHeight     =   16
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   16
      TabIndex        =   3
      Top             =   2040
      Width           =   240
      Visible         =   0   'False
   End
   Begin VB.PictureBox picBody 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   240
      Left            =   1680
      Picture         =   "frmMasken.frx":051D
      ScaleHeight     =   16
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   16
      TabIndex        =   2
      Top             =   2040
      Width           =   240
      Visible         =   0   'False
   End
   Begin VB.PictureBox picBlack 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H00000000&
      FillStyle       =   0  'Solid
      ForeColor       =   &H80000008&
      Height          =   735
      Left            =   240
      ScaleHeight     =   705
      ScaleWidth      =   915
      TabIndex        =   1
      Top             =   1920
      Width           =   945
      Visible         =   0   'False
   End
   Begin VB.PictureBox picField 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00000000&
      BorderStyle     =   0  'None
      ClipControls    =   0   'False
      DrawStyle       =   5  'Transparent
      FillStyle       =   0  'Solid
      Height          =   1035
      Left            =   240
      ScaleHeight     =   69
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   137
      TabIndex        =   0
      Top             =   600
      Width           =   2055
   End
   Begin VB.Label lblScore 
      Caption         =   "Score:"
      Height          =   255
      Left            =   1200
      TabIndex        =   4
      Top             =   0
      Width           =   2175
   End
   Begin VB.Menu mnuGame 
      Caption         =   "&Spel"
      Begin VB.Menu mnuAbout 
         Caption         =   "&Om"
      End
      Begin VB.Menu mnuHighScore 
         Caption         =   "&High-Score"
      End
      Begin VB.Menu mnuNewGame 
         Caption         =   "&Nytt-Spel"
         Shortcut        =   {F5}
      End
      Begin VB.Menu mnuSound 
         Caption         =   "&Ljud"
         Checked         =   -1  'True
      End
      Begin VB.Menu mnuExit 
         Caption         =   "&Avsluta"
      End
   End
   Begin VB.Menu mnuLevelMain 
      Caption         =   "&Niv"
      Begin VB.Menu mnuLevel 
         Caption         =   "&Nybrjare"
         Index           =   0
      End
      Begin VB.Menu mnuLevel 
         Caption         =   "&Medium"
         Index           =   1
      End
      Begin VB.Menu mnuLevel 
         Caption         =   "&Proffs"
         Index           =   2
      End
      Begin VB.Menu mnuLevel 
         Caption         =   "Mask&frare"
         Index           =   3
      End
   End
End
Attribute VB_Name = "frmMasken"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'-------------------------------------------------------------------------
'Author:    Anders Fransson
'Email:     anders.fransson@home.se
'Internet:  http://hem1.passagen.se/fylke
'Date:      98-05-10
'-------------------------------------------------------------------------

Option Explicit

Private WithEvents Timer1 As ccrpTimer
Attribute Timer1.VB_VarHelpID = -1

Private m_iDirection As Integer             'Current direction (0-3)
Private m_iLengthUnit As Integer            'One lenght unit (depends on bodysegment)
Private m_iNoSegments As Integer            'Number of bodysegment
Private m_iFirst As Integer                 'Index of first bodysegment
Private m_iLast As Integer                  'Index of last bodysegment
Private m_iScore As Integer                 'Score
Private m_iLevel As Integer                 'Level (0-3)
Private m_vLevel As Variant                 'String array with levels

'Directions
Private Const DIR_LEFT As Integer = 0
Private Const DIR_DOWN  As Integer = 1
Private Const DIR_RIGHT  As Integer = 2
Private Const DIR_UP  As Integer = 3

'Level
Private Const LEVEL_BEGINNER As Integer = 140
Private Const LEVEL_MEDIUM As Integer = 100
Private Const LEVEL_PRO As Integer = 60
Private Const LEVEL_HARD As Integer = 20

'Size
Private Const X_SIZE  As Integer = 39
Private Const Y_SIZE  As Integer = 26
Private Const WORM_START_SIZE  As Integer = 4
Private Const WORM_RESIZE  As Integer = 6

'Text constants
Private Const TEXT_HIGH_SCORE As String = "High Score"
Private Const TEXT_INPUT_PLAYER As String = "Skriv ditt namn!"
Private Const TEXT_LEVEL As String = "Niv"
Private Const TEXT_PLAYER As String = "Spelare"
Private Const TEXT_SCORE As String = "Pong"
Private Const TEXT_BEGINNER As String = "Nybrjare"
Private Const TEXT_MEDIUM As String = "Medium"
Private Const TEXT_PRO As String = "Proffs"
Private Const TEXT_HARD As String = "Maskfrare"

'Registry constants
Private Const TEXT_ANDERS_GAMES As String = "Anders Franssons Made In Home Games"
Private Const TEXT_REGISTRY_WORM As String = "Masken"
Private Const TEXT_REGISTRY_PLAYER As String = "Player"

'Data for body segments
Private Type tBodyData
    Left As Integer
    Top As Integer
    IndexAhead As Integer
End Type
Private m_vBodyData(0 To X_SIZE * Y_SIZE) As tBodyData
Private m_bCoord(X_SIZE - 1, Y_SIZE - 1) As Boolean

Private Sub Form_Load()

    Set Timer1 = New ccrpTimer
    
    'Timer properties
    With Timer1
        .EventType = TimerPeriodic
        .Stats.Frequency = 10
    End With
    
    'Set lenght unit to the width of a bodysegment
    m_iLengthUnit = picBody.Width

    'Place the field
    picField.Move 5, m_iLengthUnit, _
        m_iLengthUnit * X_SIZE, m_iLengthUnit * Y_SIZE
    
    'Select medium level
    mnuLevel_Click (1)
    
    'Start values
    Me.Caption = TEXT_REGISTRY_WORM
    Me.Height = 7200
    Me.Width = 9600
    lblScore.Move X_SIZE * m_iLengthUnit / 2 - 10, 0
    m_vLevel = Array(TEXT_BEGINNER, TEXT_MEDIUM, TEXT_PRO, TEXT_HARD)

    'Initialize random number generator
    Randomize
    
    NewGame

End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)

    If mnuLevelMain.Enabled Then Exit Sub

    'Update direction
    Select Case KeyCode
    
        Case vbKeyLeft, vbKeyNumpad4, 65
            If Not Timer1.Enabled Then Exit Sub
            m_iDirection = (m_iDirection + 1) Mod 4
            Me.KeyPreview = False
            
        Case vbKeyRight, vbKeyNumpad6, 222
            If Not Timer1.Enabled Then Exit Sub
            m_iDirection = (m_iDirection + 3) Mod 4
            Me.KeyPreview = False
            
        Case vbKeyPause: Timer1.Enabled = Not Timer1.Enabled
            
    End Select
    
End Sub

Private Sub mnuAbout_Click()
    frmAbout.ShowAboutForm Me.Caption, Me.Icon
End Sub

Private Sub mnuExit_Click()
    Unload Me
End Sub

Private Sub mnuHighScore_Click()
    
    Dim i%
    Dim sHighScore As String, strTab As String
    
    sHighScore = TEXT_LEVEL & vbTab & vbTab & TEXT_SCORE & vbTab & vbTab & _
        TEXT_PLAYER & vbNewLine & vbNewLine
        
    'Get high score from registry
    For i = 0 To 3
        strTab = vbTab
        If Len(m_vLevel(i)) < 10 Then strTab = vbTab & vbTab
        sHighScore = sHighScore & m_vLevel(i) & strTab & _
            GetSetting(TEXT_ANDERS_GAMES, TEXT_REGISTRY_WORM, i, "-") & vbTab & vbTab & _
            GetSetting(TEXT_ANDERS_GAMES, TEXT_REGISTRY_WORM, TEXT_REGISTRY_PLAYER & i, "-") & _
            vbNewLine
    Next

    'Show high score in msgbox
    MsgBox sHighScore, vbOKOnly, TEXT_HIGH_SCORE

End Sub

Private Sub mnuNewGame_Click()
    NewGame
End Sub

Private Sub mnuSound_Click()
    mnuSound.Checked = Not mnuSound.Checked
End Sub

Private Sub mnuLevel_Click(Index As Integer)

    Dim i%
    
    For i = 0 To 3
        mnuLevel(i).Checked = False
    Next
    
    m_iLevel = Index
    mnuLevel(Index).Checked = True
    
    Select Case Index
        Case 0: Timer1.Interval = LEVEL_BEGINNER
        Case 1: Timer1.Interval = LEVEL_MEDIUM
        Case 2: Timer1.Interval = LEVEL_PRO
        Case 3: Timer1.Interval = LEVEL_HARD
    End Select

End Sub

Private Sub Timer1_Timer(ByVal Milliseconds As Long)

    Static iResizeIndex%
    Dim i%, iRandX%, iRandY%

    On Error GoTo TimerError

    'Place black over last bodysegment
    RemoveBody m_vBodyData(m_iLast).Left, m_vBodyData(m_iLast).Top
    
    'Update resize index
    iResizeIndex = iResizeIndex + 1
    If iResizeIndex = WORM_RESIZE + 1 Then iResizeIndex = 0

    'If time to resize then add body segment at the end
    If iResizeIndex = WORM_RESIZE Then
        m_iNoSegments = m_iNoSegments + 1
        m_vBodyData(m_iNoSegments).Left = m_vBodyData(m_iLast).Left
        m_vBodyData(m_iNoSegments).Top = m_vBodyData(m_iLast).Top
        PlaceBody m_vBodyData(m_iNoSegments).Left, m_vBodyData(m_iNoSegments).Top
        m_vBodyData(m_iNoSegments).IndexAhead = m_iLast
        m_iLast = m_iNoSegments
    End If
    
    'Move the last body segment to the heads position
    m_vBodyData(m_iLast).Left = picHead.Left
    m_vBodyData(m_iLast).Top = picHead.Top
    PlaceBody m_vBodyData(m_iLast).Left, m_vBodyData(m_iLast).Top
    
    'Change direction
    Select Case m_iDirection
        Case DIR_LEFT: picHead.Left = picHead.Left - m_iLengthUnit
        Case DIR_RIGHT: picHead.Left = picHead.Left + m_iLengthUnit
        Case DIR_DOWN: picHead.Top = picHead.Top + m_iLengthUnit
        Case DIR_UP: picHead.Top = picHead.Top - m_iLengthUnit
    End Select
    
    'If crach
    If (picHead.Top < 0) Or (picHead.Top >= Y_SIZE * m_iLengthUnit) Or _
        (picHead.Left < 0) Or (picHead.Left >= X_SIZE * m_iLengthUnit) Or _
        m_bCoord(Int(picHead.Left / m_iLengthUnit), Int(picHead.Top / m_iLengthUnit)) _
        Then Crash
   
    'Place head
    PlaceHead picHead.Left, picHead.Top
    
    'If food is eaten, remove it an place new (but not over the worm)
    If (picHead.Left - picFood.Left < 2 * m_iLengthUnit) And _
        (picHead.Left - picFood.Left >= 0) And _
        (picHead.Top - picFood.Top < 2 * m_iLengthUnit) And _
        (picHead.Top - picFood.Top) >= 0 Then
            If mnuSound.Checked Then PlaySound App.Path & "\Eat.wav"
            m_iScore = m_iScore + 1
            lblScore = m_vLevel(m_iLevel) & ": " & m_iScore
        i = 0
        Do
            i = i + 1
            iRandX = Int((X_SIZE - 1) * Rnd)
            iRandY = Int((Y_SIZE - 1) * Rnd)
        Loop While m_bCoord(iRandX, iRandY) Or m_bCoord(iRandX + 1, iRandY) Or _
             m_bCoord(iRandX, iRandY + 1) Or m_bCoord(iRandX + 1, iRandY + 1)
        RemoveFood picFood.Left, picFood.Top
        picFood.Move iRandX * m_iLengthUnit, iRandY * m_iLengthUnit
        PlaceFood picFood.Left, picFood.Top
    End If
            
    'Place head
    PlaceHead picHead.Left, picHead.Top
    
    'Update data for body segments
    m_vBodyData(m_iFirst).IndexAhead = m_iLast
    m_iFirst = m_iLast
    m_iLast = m_vBodyData(m_iLast).IndexAhead

    'Update the field picture
    picField.Refresh
    
    'Keyboard events allowed until next keyboard event
    Me.KeyPreview = True

    Exit Sub

TimerError:

    Crash
    
End Sub

Private Sub Crash()
    
    picField.Refresh
    Timer1.Enabled = False
    If mnuSound.Checked Then PlaySound App.Path & "\WallHit.wav"
    mnuLevelMain.Enabled = True
    
    'If high score
    If m_iScore > GetSetting(TEXT_ANDERS_GAMES, TEXT_REGISTRY_WORM, m_iLevel, 0) Then
        SaveSetting TEXT_ANDERS_GAMES, TEXT_REGISTRY_WORM, m_iLevel, m_iScore
        SaveSetting TEXT_ANDERS_GAMES, TEXT_REGISTRY_WORM, TEXT_REGISTRY_PLAYER & m_iLevel, _
            Left(Trim(InputBox(TEXT_INPUT_PLAYER, TEXT_HIGH_SCORE)), 20)
    End If
    
End Sub

Private Sub NewGame()

    Dim i%, j%, iRandX%, iRandY%

    'Reset the coord data
    For i = 0 To X_SIZE - 1
        For j = 0 To Y_SIZE - 1
            m_bCoord(i, j) = False
        Next
    Next

    'Clear the background
    picField.Cls
    
    'Place the head
    picHead.Move Int(X_SIZE / 2) * m_iLengthUnit, Int(Y_SIZE / 2) * m_iLengthUnit
    PlaceHead picHead.Left, picHead.Top
    
    'Place the first body segment
    m_vBodyData(0).Left = picHead.Left - m_iLengthUnit
    m_vBodyData(0).Top = picHead.Top
    PlaceBody m_vBodyData(0).Left, m_vBodyData(0).Top
    
    'Place the rest of the "init worm"
    For i = 1 To WORM_START_SIZE - 1
        m_vBodyData(i).Left = m_vBodyData(0).Left - i * m_iLengthUnit
        m_vBodyData(i).Top = m_vBodyData(0).Top
        PlaceBody m_vBodyData(i).Left, m_vBodyData(i).Top
        m_vBodyData(i).IndexAhead = i - 1
    Next
    
    'Chose coords for the first food random (but not over the worm)
    Do
        iRandX = Int((X_SIZE - 1) * Rnd)
        iRandY = Int((Y_SIZE - 1) * Rnd)
    Loop While m_bCoord(iRandX, iRandY) Or m_bCoord(iRandX + 1, iRandY) Or _
         m_bCoord(iRandX, iRandY + 1) Or m_bCoord(iRandX + 1, iRandY + 1)
         
    'Place first food
    picFood.Move iRandX * m_iLengthUnit, iRandY * m_iLengthUnit
    PlaceFood picFood.Left, picFood.Top
    
    'Start values
    mnuLevelMain.Enabled = False
    m_iDirection = DIR_RIGHT
    m_iFirst = 0
    m_iLast = WORM_START_SIZE - 1
    m_iNoSegments = m_iLast
    m_iScore = 0
    lblScore = m_vLevel(m_iLevel) & ": " & m_iScore
    Timer1.Enabled = True
    
End Sub

Private Function PlaceBody(ByVal lLeft As Long, ByVal lTop As Long) As Long
    PlaceBody = BitBlt(picField.hDC, lLeft, lTop, m_iLengthUnit, m_iLengthUnit, _
        picBody.hDC, 0, 0, SRCCOPY)
    m_bCoord(Int(lLeft / m_iLengthUnit), Int(lTop / m_iLengthUnit)) = True
End Function

Private Function RemoveBody(ByVal lLeft As Long, ByVal lTop As Long) As Long
    RemoveBody = BitBlt(picField.hDC, lLeft, lTop, m_iLengthUnit, m_iLengthUnit, _
        picBlack.hDC, 0, 0, SRCCOPY)
    m_bCoord(Int(lLeft / m_iLengthUnit), Int(lTop / m_iLengthUnit)) = False
End Function

Private Function PlaceHead(ByVal lLeft As Long, ByVal lTop As Long) As Long
    PlaceHead = BitBlt(picField.hDC, lLeft, lTop, m_iLengthUnit, m_iLengthUnit, _
        picHead.hDC, 0, 0, SRCCOPY)
    m_bCoord(Int(lLeft / m_iLengthUnit), Int(lTop / m_iLengthUnit)) = True
End Function

Private Function PlaceFood(ByVal lLeft As Long, ByVal lTop As Long) As Long
    PlaceFood = BitBlt(picField.hDC, lLeft, lTop, 2 * m_iLengthUnit, 2 * m_iLengthUnit, _
        picFood.hDC, 0, 0, SRCCOPY)
End Function

Private Function RemoveFood(ByVal lLeft As Long, ByVal lTop As Long) As Long
    RemoveFood = BitBlt(picField.hDC, lLeft, lTop, 2 * m_iLengthUnit, 2 * m_iLengthUnit, _
        picBlack.hDC, 0, 0, SRCCOPY)
End Function

Private Sub PlaySound(strSound As String)
    sndPlaySound strSound, SND_ASYNC Or SND_NODEFAULT
End Sub



